searchNodes=[{"ref":"Xgit.html","title":"Xgit","type":"module","doc":"Just a tiny little project."},{"ref":"Xgit.html#start/2","title":"Xgit.start/2","type":"function","doc":"Start Xgit application."},{"ref":"Xgit.Core.ContentSource.html","title":"Xgit.Core.ContentSource","type":"protocol","doc":"Protocol used for reading object content from various sources."},{"ref":"Xgit.Core.ContentSource.html#length/1","title":"Xgit.Core.ContentSource.length/1","type":"function","doc":"Calculate the length (in bytes) of the content."},{"ref":"Xgit.Core.ContentSource.html#stream/1","title":"Xgit.Core.ContentSource.stream/1","type":"function","doc":"Return a stream which can be used for reading the content."},{"ref":"Xgit.Core.ContentSource.html#t:t/0","title":"Xgit.Core.ContentSource.t/0","type":"type","doc":"Any value for which ContentSource protocol is implemented."},{"ref":"Xgit.Core.FileContentSource.html","title":"Xgit.Core.FileContentSource","type":"module","doc":"Implements Xgit.Core.ContentSource to read content from a file on disk."},{"ref":"Xgit.Core.FileContentSource.html#new/1","title":"Xgit.Core.FileContentSource.new/1","type":"function","doc":"Creates an Xgit.Core.FileContentSource for a file on disk."},{"ref":"Xgit.Core.FileContentSource.html#t:t/0","title":"Xgit.Core.FileContentSource.t/0","type":"type","doc":"Describes a file on disk which will be used for reading content."},{"ref":"Xgit.Core.FileMode.html","title":"Xgit.Core.FileMode","type":"module","doc":"Describes the file type as represented on disk."},{"ref":"Xgit.Core.FileMode.html#executable_file/0","title":"Xgit.Core.FileMode.executable_file/0","type":"function","doc":"Mode indicating an entry is an executable file."},{"ref":"Xgit.Core.FileMode.html#executable_file?/1","title":"Xgit.Core.FileMode.executable_file?/1","type":"function","doc":"Return true if the file omde represents an executable file."},{"ref":"Xgit.Core.FileMode.html#gitlink/0","title":"Xgit.Core.FileMode.gitlink/0","type":"function","doc":"Mode indicating an entry is a submodule commit in another repository."},{"ref":"Xgit.Core.FileMode.html#gitlink?/1","title":"Xgit.Core.FileMode.gitlink?/1","type":"function","doc":"Return true if the file mode represents a submodule commit in another repository."},{"ref":"Xgit.Core.FileMode.html#is_file_mode/1","title":"Xgit.Core.FileMode.is_file_mode/1","type":"macro","doc":"This guard requires the value to be one of the known git file mode values."},{"ref":"Xgit.Core.FileMode.html#regular_file/0","title":"Xgit.Core.FileMode.regular_file/0","type":"function","doc":"Mode indicating an entry is a non-executable file."},{"ref":"Xgit.Core.FileMode.html#regular_file?/1","title":"Xgit.Core.FileMode.regular_file?/1","type":"function","doc":"Return true if the file mode represents a regular file."},{"ref":"Xgit.Core.FileMode.html#symlink/0","title":"Xgit.Core.FileMode.symlink/0","type":"function","doc":"Mode indicating an entry is a symbolic link."},{"ref":"Xgit.Core.FileMode.html#symlink?/1","title":"Xgit.Core.FileMode.symlink?/1","type":"function","doc":"Return true if the file mode a symbolic link."},{"ref":"Xgit.Core.FileMode.html#tree/0","title":"Xgit.Core.FileMode.tree/0","type":"function","doc":"Mode indicating an entry is a tree (aka directory)."},{"ref":"Xgit.Core.FileMode.html#tree?/1","title":"Xgit.Core.FileMode.tree?/1","type":"function","doc":"Return true if the file mode represents a tree."},{"ref":"Xgit.Core.FileMode.html#valid?/1","title":"Xgit.Core.FileMode.valid?/1","type":"function","doc":"Return true if the value is one of the known file mode values."},{"ref":"Xgit.Core.FileMode.html#t:t/0","title":"Xgit.Core.FileMode.t/0","type":"type","doc":"An integer describing the file type as represented on disk. Git uses a variation on the Unix file permissions flags to denote a file&#39;s intended type on disk. The following values are recognized: 0o100644 - normal file 0o100755 - executable file 0o120000 - symbolic link 0o040000 - tree (subdirectory) 0o160000 - submodule (aka gitlink) This module is intended to be used. Doing so will create an alias to the module so as to make FileMode.t available for typespecs and will import the is_file_mode/1 guard."},{"ref":"Xgit.Core.Object.html","title":"Xgit.Core.Object","type":"module","doc":"Describes a single object stored (or about to be stored) in a git repository. This struct is constructed, modified, and shared as a working description of how to find and describe an object before it gets written to a repository."},{"ref":"Xgit.Core.Object.html#t:t/0","title":"Xgit.Core.Object.t/0","type":"type","doc":"This struct describes a single object stored or about to be stored in a git repository. Struct Members :type: the object&#39;s type (:blob, :tree, :commit, or :tag) :content: how to obtain the content (see Xgit.Core.ContentSource) :size: size (in bytes) of the object or :unknown :id: object ID (40 chars hex) of the object or :unknown"},{"ref":"Xgit.Core.ObjectId.html","title":"Xgit.Core.ObjectId","type":"module","doc":"An object ID is a string that identifies an object within a repository. This string must match the format for a SHA-1 hash (i.e. 40 characters of lowercase hex)."},{"ref":"Xgit.Core.ObjectId.html#calculate_id/2","title":"Xgit.Core.ObjectId.calculate_id/2","type":"function","doc":"Assign an object ID for a given data blob. No validation is performed on the content. Parameters data describes how to read the data. (See Xgit.Core.ContentSource.) type is the intended git object type for this data. (See Xgit.Core.ObjectType.) Return Value The object ID. (See Xgit.Core.ObjectId.)"},{"ref":"Xgit.Core.ObjectId.html#from_hex_charlist/1","title":"Xgit.Core.ObjectId.from_hex_charlist/1","type":"function","doc":"Read an object ID from a hex string (charlist). Return Value If a valid ID is found, returns {id, next} where id is the matched ID as a string and next is the remainder of the charlist after the matched ID. If no such ID is found, returns false."},{"ref":"Xgit.Core.ObjectId.html#valid?/1","title":"Xgit.Core.ObjectId.valid?/1","type":"function","doc":"Returns true if the value is a valid object ID. (In other words, is it a string containing 40 characters of lowercase hex?)"},{"ref":"Xgit.Core.ObjectId.html#zero/0","title":"Xgit.Core.ObjectId.zero/0","type":"function","doc":"Get the special all-null object ID, often used to stand-in for no object."},{"ref":"Xgit.Core.ObjectId.html#t:t/0","title":"Xgit.Core.ObjectId.t/0","type":"type","doc":"A string containing 40 bytes of lowercase hex digits."},{"ref":"Xgit.Core.ObjectType.html","title":"Xgit.Core.ObjectType","type":"module","doc":"Describes the known git object types. There are four distinct object types that can be stored in a git repository. Xgit communicates internally about these object types using the following atoms: :blob :tree :commit :tag This module is intended to be used. Doing so will create an alias to the module so as to make ObjectType.t available for typespecs and will import the is_object_type/1 guard."},{"ref":"Xgit.Core.ObjectType.html#is_object_type/1","title":"Xgit.Core.ObjectType.is_object_type/1","type":"macro","doc":"This guard requires the value to be one of the four known git object types."},{"ref":"Xgit.Core.ObjectType.html#valid?/1","title":"Xgit.Core.ObjectType.valid?/1","type":"function","doc":"Return true if the value is one of the four known git object types."},{"ref":"Xgit.Core.ObjectType.html#t:t/0","title":"Xgit.Core.ObjectType.t/0","type":"type","doc":"One of the four known git object types, expressed as an atom."},{"ref":"Xgit.Core.PersonIdent.html","title":"Xgit.Core.PersonIdent","type":"module","doc":"A combination of a person identity and time in git."},{"ref":"Xgit.Core.PersonIdent.html#format_timezone/1","title":"Xgit.Core.PersonIdent.format_timezone/1","type":"function","doc":"Formats a timezone offset."},{"ref":"Xgit.Core.PersonIdent.html#from_byte_list/1","title":"Xgit.Core.PersonIdent.from_byte_list/1","type":"function","doc":"Parse a name line (e.g. author, committer, tagger) into a PersonIdent struct. Parameters b should be a charlist of an &quot;author&quot; or &quot;committer&quot; line pointing to the character after the header name and space. The functions Xgit.Util.RawParseUtils.author/1 and Xgit.Util.RawParseUtils.committer/1 will return suitable charlists. Return Value Returns a PersonIdent struct or nil if the charlist did not point to a properly-formatted identity."},{"ref":"Xgit.Core.PersonIdent.html#sanitized/1","title":"Xgit.Core.PersonIdent.sanitized/1","type":"function","doc":"Sanitize the given string for use in an identity and append to output. Trims whitespace from both ends and special characters \\n &lt; &gt; that interfere with parsing; appends all other characters to the output."},{"ref":"Xgit.Core.PersonIdent.html#to_external_string/1","title":"Xgit.Core.PersonIdent.to_external_string/1","type":"function","doc":"Formats the person identity for git storage."},{"ref":"Xgit.Core.PersonIdent.html#t:t/0","title":"Xgit.Core.PersonIdent.t/0","type":"type","doc":"The tuple of name, email, time, and time zone that specifies who wrote or committed something. Struct Members :name: (string) human-readable name of the author or committer :email: (string) e-mail address for this person :when: (integer) time in the Unix epoch in milliseconds :tz_offset: (integer) time zone offset from GMT in minutes"},{"ref":"Xgit.Core.PersonIdent.html#t:tz_offset/0","title":"Xgit.Core.PersonIdent.tz_offset/0","type":"type","doc":"Time zone offset in minutes +/- from GMT."},{"ref":"Xgit.Core.ValidateObject.html","title":"Xgit.Core.ValidateObject","type":"module","doc":"Verifies that an object is formatted correctly. Verifications made by this module only check that the fields of an object are formatted correctly. The object ID checksum of the object is not verified, and connectivity links between objects are also not verified. It&#39;s assumed that the caller can provide both of these validations on its own."},{"ref":"Xgit.Core.ValidateObject.html#check/2","title":"Xgit.Core.ValidateObject.check/2","type":"function","doc":"Verify that a proposed object is valid. Options By default, this function will only enforce Posix file name restrictions. :macosx?: true to also enforce Mac OS X file name restrictions :windows?: true to also enforce Windows file name restrictions Return Value :ok if the object is successfully validated. {:error, &quot;reason&quot;} if the object can not be validated."},{"ref":"Xgit.Core.ValidatePath.html","title":"Xgit.Core.ValidatePath","type":"module","doc":"Verifies that a path is an acceptable part of a tree structure."},{"ref":"Xgit.Core.ValidatePath.html#check_path/2","title":"Xgit.Core.ValidatePath.check_path/2","type":"function","doc":"Check the provided path to see if it is a valid path within a git repository. The rules enforced here are slightly different from what is allowed in a tree object in that we allow / characters to build hierarchical paths. Parameters path is a UTF-8 byte list containing the path to be tested. Options windows?: true to additionally verify that the path is permissible on Windows file systems macosx?: true to additionally verify that the path is permissible on Mac OS X file systems Return Values :ok if the name is permissible given the constraints chosen above {:error, &quot;reason&quot;} if the name is not permissible"},{"ref":"Xgit.Core.ValidatePath.html#check_path_segment/2","title":"Xgit.Core.ValidatePath.check_path_segment/2","type":"function","doc":"Check the provided path segment to see if it is a valid path within a git tree object. Parameters path is a UTF-8 byte list containing the path segment to be tested. Options windows?: true to additionally verify that the path is permissible on Windows file systems macosx?: true to additionally verify that the path is permissible on Mac OS X file systems Return Values :ok if the name is permissible given the constraints chosen above {:error, &quot;reason&quot;} if the name is not permissible"},{"ref":"Xgit.Core.ValidatePath.html#gitmodules?/2","title":"Xgit.Core.ValidatePath.gitmodules?/2","type":"function","doc":"Return true if the filename could be read as a .gitmodules file when checked out to the working directory. This would seem like a simple comparison, but some filesystems have peculiar rules for normalizing filenames: NTFS has backward-compatibility support for 8.3 synonyms of long file names. (See https://web.archive.org/web/20160318181041/https://usn.pw/blog/gen/2015/06/09/filenames/ for details.) NTFS is also case-insensitive. MacOS&#39;s HFS+ folds away ignorable Unicode characters in addition to case folding. Parameters path is a UTF-8 byte list containing the path to be tested. Options By default, this function will only check for the plain .gitmodules name. windows?: true to additionally check for any path that might be treated as a .gitmodules file on Windows file systems macosx?: true to additionally check for any path that might be treated as a .gitmodules file on Mac OS X file systems"},{"ref":"Xgit.Core.ValidatePath.html#t:result/0","title":"Xgit.Core.ValidatePath.result/0","type":"type","doc":"Response to validation functions in this module."},{"ref":"Xgit.Plumbing.HashObject.html","title":"Xgit.Plumbing.HashObject","type":"module","doc":"Computes an object ID and optionally writes that into the repository&#39;s object store. Analogous to git hash-object."},{"ref":"Xgit.Plumbing.HashObject.html#run/2","title":"Xgit.Plumbing.HashObject.run/2","type":"function","doc":"Computes an object ID and optionally writes that into the repository&#39;s object store. Parameters content describes how this function should obtain the content. (See Xgit.Core.ContentSource.) Options :type: the object&#39;s type Type: Xgit.Core.ObjectType Default: :blob See -t option on git hash-object. :validate?: true to verify that the object is valid for :type Type: boolean Default: true This is the inverse of the --literally option on git hash-object. :repo: where the content should be stored Type: Xgit.Repository (PID) Default: nil :write?: true to write the object into the repository Type: boolean Default: false This option is meaningless if :repo is not specified. See -w option on git hash-object. TO DO: There is no support, at present, for filters as defined in a .gitattributes file. See issue #18. Return Value {:ok, object_id} if the object could be validated and assigned an ID. {:error, &quot;reason&quot;} if unable."},{"ref":"Xgit.Repository.html","title":"Xgit.Repository","type":"behaviour","doc":"Represents an abstract git repository. Looking for Typical Git Commands? The operations to inspect or mutate a git repository are not located in this module. (See Design Goals, below, and the README.md file in the lib/xgit folder for an explanation.) You&#39;ll find these operations in the modules named Xgit.Api.* (none yet as of this writing) and Xgit.Plumbing.* Design Goals Xgit intends to allow repositories to be stored in multiple different mechanisms. While it includes built-in support for local on-disk repositories (see Xgit.Repository.OnDisk), you could envision repositories stored entirely in memory, or on a remote file system or database. Implementing a Storage Architecture To define a new mechanism for storing a git repo, start by creating a new module that uses this module and implements the required callbacks. Consider the information stored in a typical .git directory in a local repository. You will be building an alternative to that storage mechanism."},{"ref":"Xgit.Repository.html#child_spec/1","title":"Xgit.Repository.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Repository.html#c:handle_put_loose_object/2","title":"Xgit.Repository.handle_put_loose_object/2","type":"callback","doc":"Writes a loose object to the repository. Called when put_loose_object/2 is called. Return Value Should return :ok if written successfully. Should return {:error, &quot;reason&quot;} if unable to write the object."},{"ref":"Xgit.Repository.html#put_loose_object/2","title":"Xgit.Repository.put_loose_object/2","type":"function","doc":"Writes a loose object to the repository. Return Value :ok if written successfully. {:error, &quot;reason&quot;} if unable to write the object."},{"ref":"Xgit.Repository.html#start_link/3","title":"Xgit.Repository.start_link/3","type":"function","doc":"Starts a Repository process linked to the current process. IMPORTANT: You should not invoke this function directly unless you are implementing a new storage implementation module that implements this behaviour. Parameters module is the name of a module that implements the callbacks defined in this module. init_arg is passed to the init/1 function of module. options are passed to GenServer.start_link/3. Return Value See GenServer.start_link/3."},{"ref":"Xgit.Repository.html#valid?/1","title":"Xgit.Repository.valid?/1","type":"function","doc":"Returns true if the argument is a PID representing a valid Repository process."},{"ref":"Xgit.Repository.html#t:t/0","title":"Xgit.Repository.t/0","type":"type","doc":"The process ID for a Repository process."},{"ref":"Xgit.Repository.OnDisk.html","title":"Xgit.Repository.OnDisk","type":"module","doc":"Implementation of Xgit.Repository that stores content on the local file system. IMPORTANT NOTE: This is intended as a reference implementation largely for testing purposes and may not necessarily handle all of the edge cases that the traditional git command-line interface will handle. That said, it does intentionally use the same .git folder format as command-line git so that results may be compared for similar operations."},{"ref":"Xgit.Repository.OnDisk.html#child_spec/1","title":"Xgit.Repository.OnDisk.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Repository.OnDisk.html#create/1","title":"Xgit.Repository.OnDisk.create/1","type":"function","doc":"Creates a new, empty git repository on the local file system. Analogous to git init. NOTE: We use the name create here so as to avoid a naming conflict with GenServer.init/1. Parameters work_dir (String) is the top-level working directory. A .git directory is created inside this directory. Return Value :ok if created successfully. {:error, &quot;reason&quot;} if not."},{"ref":"Xgit.Repository.OnDisk.html#start_link/1","title":"Xgit.Repository.OnDisk.start_link/1","type":"function","doc":"Start an on-disk git repository. Use the functions in Xgit.Repository to interact with this repository process. Options :work_dir (required): Top-level working directory. A .git directory should exist at this path. Use create/1 to create an empty on-disk repository if necessary. Any other options are passed through to GenServer.start_link/3. Return Value See GenServer.start_link/3."},{"ref":"Xgit.Util.GenServerUtils.html","title":"Xgit.Util.GenServerUtils","type":"module","doc":"Some utilities to make error handling in GenServer calls easier. Xgit is somewhat more exception-friendly than typical Elixir code."},{"ref":"Xgit.Util.GenServerUtils.html#call!/3","title":"Xgit.Util.GenServerUtils.call!/3","type":"function","doc":"Makes a synchronous call to the server and waits for its reply. Return Value If the response is :ok, return server (for function chaining). If the response is {:ok, (value)}, return value. If the response is {:error, (reason)}, raise reason as an error."},{"ref":"Xgit.Util.GenServerUtils.html#delegate_call_to/4","title":"Xgit.Util.GenServerUtils.delegate_call_to/4","type":"function","doc":"Delegate a handle_call/3 call to a handle_(something) call on a module. Wraps common :ok and error responses and exceptions and returns them to caller. Unlike wrap_call/4, assumes that the GenServer state is a tuple of {module, mod_state} and re-wraps module state accordingly."},{"ref":"Xgit.Util.GenServerUtils.html#wrap_call/4","title":"Xgit.Util.GenServerUtils.wrap_call/4","type":"function","doc":"Wrap a handle_call/3 call to a handle_(something) call on a module. Wraps common :ok and error responses and exceptions and returns them to caller. Should be used for standalone modules (i.e. modules that are not open to extension)."},{"ref":"Xgit.Util.Paths.html","title":"Xgit.Util.Paths","type":"module","doc":"Utility functions for comparing paths inside of a git repository."},{"ref":"Xgit.Util.Paths.html#compare/4","title":"Xgit.Util.Paths.compare/4","type":"function","doc":"Compare two paths according to git path sort ordering rules. Return Value :lt if path1 sorts before path2. :eq if they are the same. :gt if path1 sorts after path2."},{"ref":"Xgit.Util.Paths.html#compare_same_name/3","title":"Xgit.Util.Paths.compare_same_name/3","type":"function","doc":"Compare two paths, checking for identical name. Unlike compare/4, this method returns :eq when the paths have the same characters in their names, even if the mode differs. It is intended for use in validation routines detecting duplicate entries. Parameters mode2 is the mode of the second file. Trees are sorted as though List.last(path2) == ?/, even if no such character exists. Return :lt if no duplicate name could exist; :eq if the paths have the same name; :gt if other path2 should still be checked by caller. Return Value Returns :eq if the names are identical and a conflict exists between path1 and path2, as they share the same name. Returns :lt if all possible occurrences of path1 sort before path2 and no conflict can happen. In a properly sorted tree there are no other occurrences of path1 and therefore there are no duplicate names. Returns :gt when it is possible for a duplicate occurrence of path1 to appear later, after path2. Callers should continue to examine candidates for path2 until the method returns one of the other return values."},{"ref":"Xgit.Util.Paths.html#strip_trailing_separator/1","title":"Xgit.Util.Paths.strip_trailing_separator/1","type":"function","doc":"Remove trailing / if present."},{"ref":"Xgit.Util.Paths.html#t:comparison_result/0","title":"Xgit.Util.Paths.comparison_result/0","type":"type","doc":"Comparison result."},{"ref":"Xgit.Util.RawParseUtils.html","title":"Xgit.Util.RawParseUtils","type":"module","doc":"Handy utility functions to parse raw object contents."},{"ref":"Xgit.Util.RawParseUtils.html#after_prefix/2","title":"Xgit.Util.RawParseUtils.after_prefix/2","type":"function","doc":"Return the portion of the charlist b that starts with the prefix prefix. Return Values If b does in fact start with prefix, return the portion of the charlist that follows prefix. If not, return nil."},{"ref":"Xgit.Util.RawParseUtils.html#author/1","title":"Xgit.Util.RawParseUtils.author/1","type":"function","doc":"Locate the author header line data. Returns a charlist beginning just after the space in author which should be the first character of the author&#39;s name. If no author header can be located, nil is returned."},{"ref":"Xgit.Util.RawParseUtils.html#committer/1","title":"Xgit.Util.RawParseUtils.committer/1","type":"function","doc":"Locate the committer header line data. Returns a charlist beginning just after the space in committer which should be the first character of the committer&#39;s name. If no committer header can be located, nil is returned."},{"ref":"Xgit.Util.RawParseUtils.html#decode/1","title":"Xgit.Util.RawParseUtils.decode/1","type":"function","doc":"Convert a list of bytes to an Elixir (UTF-8) string when the encoding is not definitively known. Try parsing as a UTF-8 byte array first, then try ISO-8859-1. PORTING NOTE: A lot of the simplification of this compared to jgit&#39;s implementation of RawParseUtils.decode comes from the observation that the only character set ever passed to jgit&#39;s decode was UTF-8. We&#39;ve baked that assumption into this implementation. Should other character sets come into play, this will necessarily become more complicated."},{"ref":"Xgit.Util.RawParseUtils.html#encoding/1","title":"Xgit.Util.RawParseUtils.encoding/1","type":"function","doc":"Locate the encoding header line data. Returns a charlist beginning just after the space in encoding which should be the first character of the encoding&#39;s name. If no encoding header can be located, nil is returned (and UTF-8 should be assumed)."},{"ref":"Xgit.Util.RawParseUtils.html#header_end/1","title":"Xgit.Util.RawParseUtils.header_end/1","type":"function","doc":"Locate the end of the header. Note that headers may be more than one line long. Returns charlist beginning just after the header. This is either [] or the charlist beginning with the \\n character that terminates the header."},{"ref":"Xgit.Util.RawParseUtils.html#header_start/2","title":"Xgit.Util.RawParseUtils.header_start/2","type":"function","doc":"Find the start of the contents of a given header in the given charlist. Returns charlist beginning at the start of the header&#39;s contents or nil if not found. PORTING NOTE: Unlike the jgit version of this function, it does not advance to the beginning of the next line. Because the API speaks in charlists, we cannot differentiate between the beginning of the initial string buffer and a subsequent internal portion of the buffer. Clients may need to add their own call to next_lf/1 where it would not have been necessary in jgit."},{"ref":"Xgit.Util.RawParseUtils.html#next/2","title":"Xgit.Util.RawParseUtils.next/2","type":"function","doc":"Locate the first position after a given character."},{"ref":"Xgit.Util.RawParseUtils.html#next_lf/1","title":"Xgit.Util.RawParseUtils.next_lf/1","type":"function","doc":"Locate the first position after the next LF. This method stops on the first \\n it finds."},{"ref":"Xgit.Util.RawParseUtils.html#next_lf/2","title":"Xgit.Util.RawParseUtils.next_lf/2","type":"function","doc":"Locate the first position of either the given character or LF. This method stops on the first match it finds from either char or \\n."},{"ref":"Xgit.Util.RawParseUtils.html#parse_base_10/1","title":"Xgit.Util.RawParseUtils.parse_base_10/1","type":"function","doc":"Parse a base-10 numeric value from a charlist of ASCII digits into a number. Similar to Integer.parse/2 but uses charlist instead. Digit sequences can begin with an optional run of spaces before the sequence, and may start with a + or a - to indicate sign position. Any other characters will cause the method to stop and return the current result to the caller. Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_encoding/1","title":"Xgit.Util.RawParseUtils.parse_encoding/1","type":"function","doc":"Parse the encoding header into a character set reference. Returns :utf8 or :latin1. Raises ArgumentError if the character set is unknown. WARNING: Compared to jgit, the character set support in xgit is limited."},{"ref":"Xgit.Util.RawParseUtils.html#parse_encoding_name/1","title":"Xgit.Util.RawParseUtils.parse_encoding_name/1","type":"function","doc":"Parse the encoding header as a string. Returns the encoding header as specified in the commit or nil if the header was not present and UTF-8 should be assumed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int16/1","title":"Xgit.Util.RawParseUtils.parse_hex_int16/1","type":"function","doc":"Parse 4 hex digits from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int32/1","title":"Xgit.Util.RawParseUtils.parse_hex_int32/1","type":"function","doc":"Parse 8 hex digits from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int4/1","title":"Xgit.Util.RawParseUtils.parse_hex_int4/1","type":"function","doc":"Parse a single hex digit from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int64/1","title":"Xgit.Util.RawParseUtils.parse_hex_int64/1","type":"function","doc":"Parse 16 hex digits from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_timezone_offset/1","title":"Xgit.Util.RawParseUtils.parse_timezone_offset/1","type":"function","doc":"Parse a git-style timezone string. The sequence -0315 will be parsed as the numeric value -195, as the lower two positions count minutes, not 100ths of an hour. Return Value Returns {number, new_buffer} where number is the time zone offset in minutes that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#tagger/1","title":"Xgit.Util.RawParseUtils.tagger/1","type":"function","doc":"Locate the tagger header line data. Returns a charlist beginning just after the space in tagger which should be the first character of the tagger&#39;s name. If no tagger header can be located, nil is returned."},{"ref":"Xgit.Util.RawParseUtils.html#until_end_of_paragraph/1","title":"Xgit.Util.RawParseUtils.until_end_of_paragraph/1","type":"function","doc":"Return the contents of the charlist up to, but not including, the next end-of-paragraph sequence."},{"ref":"Xgit.Util.RawParseUtils.html#until_last_instance_of_trim/2","title":"Xgit.Util.RawParseUtils.until_last_instance_of_trim/2","type":"function","doc":"Return the portion of the byte array up to, but not including the last instance of ch, disregarding any trailing spaces."},{"ref":"Xgit.Util.RawParseUtils.html#until_next_lf/1","title":"Xgit.Util.RawParseUtils.until_next_lf/1","type":"function","doc":"Return the contents of the charlist up to, but not including, the next LF."},{"ref":"Xgit.Util.RawParseUtils.html#until_next_lf/2","title":"Xgit.Util.RawParseUtils.until_next_lf/2","type":"function","doc":"Return the contents of the charlist up to, but not including, the next instance of the given character or LF."}]